/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... trida Zlomek, eukliduv algoritmus, definice operatoru
*/

#include<iostream>
using namespace std;

int nsd(int x, int y);

class Zlomek
{
	int citatel = 1;
	int jmenovatel = 1;
	void zakladniTvar()
	{
		int x = nsd(citatel, jmenovatel);
		citatel /= x;
		jmenovatel /= x;

		if (jmenovatel < 0)
		{
			citatel = -citatel;
			jmenovatel = -jmenovatel;
		}
	}
public:
	void nastavCitatele(int citatel)
	{
		this->citatel = citatel;
		zakladniTvar();
	}
	void nastavJmenovatele(int jmenovatel)
	{
		//if (jmenovatel == 0)
		//	throw 1;
		this->jmenovatel = jmenovatel;
		zakladniTvar();
	}
	void nastavCitJmen(int citatel, int jmenovatel)
	{
		//if (jmenovatel == 0)
		//	throw 1;
		this->citatel = citatel;
		this->jmenovatel = jmenovatel;
		zakladniTvar();
	}

	int vratCitatele() const
	{
		return citatel;
	}
	int vratJmenovatele() const
	{
		return jmenovatel;
	}

	/* Vypis Zlomku na konzoli. */
	void vypis() const
	{
		cout << citatel << " / " << jmenovatel << endl;
	}
	Zlomek()
	{
		citatel = 1;
		jmenovatel = 1;
	}
	Zlomek(int citatel, int jmenovatel=1) : citatel(citatel), jmenovatel(jmenovatel)
	{
		zakladniTvar();
	}
};


/* Funkce vrati nejvetsiho spolecneho delitele cisel x a y.
*/
int nsd(int x, int y)
{
	if (x == 0)
		return y;
	if (y == 0)
		return x;

	if (x < 0)
		x = -x;
	if (y < 0)
		y = -y;

	while (x != y)
	{
		if (x > y)
			x -= y;
		else // if (y > x)
			y -= x;
	}
	return x;
}


/* Funkce vynasobi dva zlomky a vrati vysledek.
   Parametry jsou predavane odkazem (referenci). */
Zlomek vynasob(const Zlomek &x, const Zlomek &y)
{
	Zlomek z;
	z.nastavCitJmen(x.vratCitatele() * y.vratCitatele(),
		x.vratJmenovatele() * y.vratJmenovatele());
	return z;
}

/* Funkce vydeli dva zlomky a vrati vysledek.
   Parametry jsou predavane odkazem. */
Zlomek vydel(const Zlomek &x, const Zlomek &y)
{
	Zlomek z;
	z.nastavCitJmen(x.vratCitatele() * y.vratJmenovatele(),
		x.vratJmenovatele() * y.vratCitatele());
	return z;
}

/* Funkce secte dva zlomky a vrati vysledek.
   Parametry jsou predavane odkazem. */
Zlomek secti(const Zlomek &x, const Zlomek &y)
{
	Zlomek z;
	z.nastavCitJmen(x.vratCitatele() * y.vratJmenovatele() + y.vratCitatele() * x.vratJmenovatele(),
		x.vratJmenovatele() * y.vratJmenovatele());
	return z;
}

/* Funkce odecte dva zlomky a vrati vysledek.
   Parametry jsou predavane odkazem. */
Zlomek odecti(const Zlomek &x, const Zlomek &y)
{
	Zlomek z;
	z.nastavCitJmen(x.vratCitatele() * y.vratJmenovatele() - y.vratCitatele() * x.vratJmenovatele(),
		x.vratJmenovatele() * y.vratJmenovatele());
	return z;
}

Zlomek operator * (const Zlomek &x, const Zlomek &y)
{
	return vynasob(x, y);
}

Zlomek operator / (const Zlomek &x, const Zlomek &y)
{
	return vydel(x, y);
}

Zlomek operator + (const Zlomek &x, const Zlomek &y)
{
	return secti(x, y);
}

Zlomek operator - (const Zlomek &x, const Zlomek &y)
{
	return odecti(x, y);
}


ostream& operator << (ostream &out, const Zlomek &z)
{
	out << z.vratCitatele() << " / " << z.vratJmenovatele() << endl;
	return out;
}

int main()
{
	Zlomek x1(1,2), x2(-2,3), x4;
	//x1.nastavCitJmen(1, 2);
	//x2.nastavCitJmen(-2, 3);

	Zlomek *u = new Zlomek();
	u->vypis();
	delete u;
	u = new Zlomek(3, -4);
	u->vypis();

	Zlomek x3 = vynasob(x1, x2);
	x3.vypis();

	x3 = vynasob(*u, *u);
	x3.vypis();

	delete u;

	x3 = (x1 / x2);
	x3.vypis();
	x3 = x1 * x2 + x3 / x2 - x3 * x1;
	x3.vypis();
	cout << x3;

	// operace s nulou
	x1.nastavCitJmen(0, 6);
	x2.nastavCitJmen(1, 2);
	x3 = x1 * x2;
	x3.vypis();
	x3 = x2 / x1;
	x3.vypis();

	return 0;
}


